# sample_one.py

import wx

# class MyIconTextCtrl
# class MyFrame
# class MyPanel
# class MyApp

#---------------------------------------------------------------------------

class MyIconTextCtrl(wx.Panel):
    """
    MyIconTextCtrl.
    """
    def __init__(self, parent, pos=(50, 30), size=(200, 21)):
        """
        Create the MyIconTextCtrl.
        """        
        # Create a panel, which looks like a textctrl.
        wx.Panel.__init__(self, parent, pos=pos, size=size, style=wx.BORDER_SIMPLE)

        self.SetBackgroundColour("#c1e9ff")

        self.w, self.h = self.GetSize()

        #------------
        
        # Add a bitmap on the left side.
        bmp = wx.ArtProvider.GetBitmap(wx.ART_FIND, wx.ART_OTHER, (16, 16))

        self.staticbmp = wx.StaticBitmap(self, -1, bmp, pos=(1, 1))
        w, h = self.staticbmp.GetSize()

        # Create an invisible textctrl inside the textctrl pane.
        self.textctrl = wx.TextCtrl(self,
                                    pos=(w + 5, 2),
                                    size=(self.w - w - 8, h), 
                                    style=wx.NO_BORDER |
                                          wx.TE_PROCESS_ENTER)
        self.textctrl.SetBackgroundColour("#c1e9ff")
        self.textctrl.Bind(wx.EVT_TEXT_ENTER, self.OnDisplayText)

    #-----------------------------------------------------------------------
        
    def OnDisplayText(self, event):
        """
        Confirm user entered text.
        """
        
        wx.MessageBox("You entered : '" + self.textctrl.GetValue() + "'", "Info")

#---------------------------------------------------------------------------
        
class MyFrame(wx.Frame):
    """
    TextCtrlWithImage application frame.
    """
    def __init__ (self, parent, title):
        """
        Create the TextCtrlWithImage application frame.
        """
        wx.Frame.__init__(self, parent, title=title)

        #------------
        
        self.SetSize((340, 150))
        self.SetIcon(wx.Icon('./icons/wxwin.ico', wx.BITMAP_TYPE_ICO))
        self.SetBackgroundColour(wx.WHITE)
        
#---------------------------------------------------------------------------
        
class MyPanel(wx.Panel):
    """
    TextCtrlWithImage Panel.
    """
    def __init__ (self, parent):
        """
        Create the TextCtrlWithImage panel.
        """
        wx.Panel.__init__(self, parent)

        #------------
        
        MyIconTextCtrl(self)

#---------------------------------------------------------------------------
        
class MyApp(wx.App):
    """
    TextCtrlWithImage Application.
    """
    def OnInit(self):
        """
        Create the TextCtrlWithImage application.
        """
        
        frame = MyFrame(None, title="wx.TextCtrl (with icon)")
        panel = MyPanel(frame)
        frame.Show(True)
        
        return True

#---------------------------------------------------------------------------
    
if __name__ == '__main__':
    app = MyApp(redirect=False)
    app.MainLoop()
